import PropTypes from 'prop-types';
import React, { Children, Component, createElement } from 'react';
import firebase from 'firebase/app';
import 'firebase/database';
import shallowEqual from 'shallowequal';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};









var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};



















var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var Provider = function (_Component) {
  inherits(Provider, _Component);

  function Provider() {
    classCallCheck(this, Provider);
    return possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).apply(this, arguments));
  }

  createClass(Provider, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        firebaseApp: this.props.firebaseApp,
        firestore: this.props.firestore
      };
    }
  }, {
    key: "render",
    value: function render() {
      return Children.only(this.props.children);
    }
  }]);
  return Provider;
}(Component);

Provider.propTypes = {
  firebaseApp: PropTypes.object.isRequired,
  firestore: PropTypes.object.isRequired,
  children: PropTypes.element.isRequired
};
Provider.childContextTypes = {
  firebaseApp: PropTypes.object,
  firestore: PropTypes.object
};

var mapValues = function mapValues(object, iteratee) {
  var result = {};

  Object.keys(object).forEach(function (key) {
    return result[key] = iteratee(object[key], key, object);
  });

  return result;
};

var pickBy = function pickBy(object, predicate) {
  var result = {};

  Object.keys(object).forEach(function (key) {
    var value = object[key];

    if (predicate(value, key)) {
      result[key] = value;
    }
  });

  return result;
};

var createQueryRef = function createQueryRef(ref, query) {
  return Object.keys(query).reduce(function (queryRef, key) {
    var value = query[key];
    var args = Array.isArray(value) ? value : [value];

    return queryRef[key].apply(queryRef, toConsumableArray(args));
  }, ref);
};

var getDisplayName = function getDisplayName(Component$$1) {
  return Component$$1.displayName || Component$$1.name || "Component";
};

var mapSnapshotToValue = function mapSnapshotToValue(snapshot) {
  var result = {};

  snapshot.forEach(function (child) {
    result[child.key] = child.data();
  });

  return result;
};

// this is react-firebase.connect adapted for firestore

// import PropTypes from "prop-types";
var defaultMergeProps = function defaultMergeProps(ownProps, firebaseProps) {
  return _extends({}, ownProps, firebaseProps);
};

var mapSubscriptionsToQueries = function mapSubscriptionsToQueries(subscriptions) {
  return mapValues(subscriptions, function (value) {
    return typeof value === "string" ? { path: value } : value;
  });
};

var defaultMapFirebaseToProps = function defaultMapFirebaseToProps(props, ref, firestore) {
  return {
    firestore: firestore
  };
};

var connect = (function () {
  var mapFirebaseToProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultMapFirebaseToProps;
  var mergeProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultMergeProps;

  var mapFirebase = function mapFirebase() {
    if (typeof mapFirebaseToProps !== "function") {
      return mapFirebaseToProps;
    }

    var firebaseProps = mapFirebaseToProps.apply(undefined, arguments);

    if (firebaseProps === null || (typeof firebaseProps === "undefined" ? "undefined" : _typeof(firebaseProps)) !== "object") {
      throw new Error("react-firebase: mapFirebaseToProps must return an object. Instead received " + firebaseProps + ".");
    }

    return firebaseProps;
  };

  var computeSubscriptions = function computeSubscriptions(props, ref, firestore) {
    var firebaseProps = mapFirebase(props, ref, firestore);
    return pickBy(firebaseProps, function (prop) {
      return typeof prop === "string" || prop && prop.path;
    });
  };

  return function (WrappedComponent) {
    var FirebaseConnect = function (_Component) {
      inherits(FirebaseConnect, _Component);

      function FirebaseConnect(props, context) {
        classCallCheck(this, FirebaseConnect);

        var _this = possibleConstructorReturn(this, (FirebaseConnect.__proto__ || Object.getPrototypeOf(FirebaseConnect)).call(this, props, context));

        _this.firestore = props.firestore || context.firestore || firebase.firestore();

        // polymorph based on number of /'s in path
        _this.ref = function (path) {
          return isCollection(path) ? _this.firestore.collection(path) : _this.firestore.doc(path);
        };
        _this.state = {
          subscriptionsState: null,
          subscribeSuccess: true
        };
        return _this;
      }

      createClass(FirebaseConnect, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var subscriptions = computeSubscriptions(this.props, this.ref, this.firestore);

          this.mounted = true;
          this.subscribe(subscriptions);
        }
      }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
          var subscriptions = computeSubscriptions(this.props, this.ref, this.firestore);
          var nextSubscriptions = computeSubscriptions(nextProps, this.ref, this.firestore);
          var addedSubscriptions = pickBy(nextSubscriptions, function (path, key) {
            return !subscriptions[key];
          });
          var removedSubscriptions = pickBy(subscriptions, function (path, key) {
            return !nextSubscriptions[key];
          });
          var changedSubscriptions = pickBy(nextSubscriptions, function (path, key) {
            return subscriptions[key] && !shallowEqual(subscriptions[key], path);
          });

          this.unsubscribe(_extends({}, removedSubscriptions, changedSubscriptions));
          this.subscribe(_extends({}, addedSubscriptions, changedSubscriptions));
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.mounted = false;

          if (this.listeners) {
            this.unsubscribe(this.listeners);
          }
        }
      }, {
        key: "subscribe",
        value: function subscribe(subscriptions) {
          var _this2 = this;

          if (Object.keys(subscriptions).length < 1) {
            return;
          }

          var queries = mapSubscriptionsToQueries(subscriptions);
          var nextListeners = mapValues(queries, function (_ref, key) {
            var path = _ref.path,
                query = objectWithoutProperties(_ref, ["path"]);

            var containsOrderBy = Object.keys(query).some(function (queryKey) {
              return queryKey.startsWith("orderBy");
            });
            var subscriptionRef = createQueryRef(_this2.ref(path), //.doc(path),
            query);
            var update = function update(querySnapshot) {
              if (_this2.mounted) {
                if (isCollection(path)) {
                  // its a collection
                  var allstuff = [];
                  querySnapshot.forEach(function (snapshot) {
                    var value = containsOrderBy ? mapSnapshotToValue(snapshot) : snapshot.data();
                    value._id = snapshot.id;
                    allstuff.push(value);
                  });
                  _this2.setState(function (prevState) {
                    return {
                      subscriptionsState: _extends({}, prevState.subscriptionsState, defineProperty({}, key, allstuff))
                    };
                  });
                } else {
                  // its a document
                  var value = containsOrderBy ? mapSnapshotToValue(querySnapshot) : querySnapshot.data();

                  _this2.setState(function (prevState) {
                    return {
                      subscriptionsState: _extends({}, prevState.subscriptionsState, defineProperty({}, key, value))
                    };
                  });
                }
              }
            };
            var _unsubscribe = void 0;
            try {
              _unsubscribe = subscriptionRef.onSnapshot(update);
            } catch (err) {
              console.log("FirePup: Error occured while querying your Firestore. If this is your first time running this, you might need to enable firestore permissioning. See INSERT_CLEVER_BEAGLE_DOCS_LINK.");
              console.error(err);
              _this2.setState({ subscribeSuccess: false });
            }

            return {
              path: path,
              unsubscribe: function unsubscribe() {
                return _unsubscribe();
              }
            };
          });

          this.listeners = _extends({}, this.listeners, nextListeners);
        }
      }, {
        key: "unsubscribe",
        value: function unsubscribe(subscriptions) {
          var _this3 = this;

          if (Object.keys(subscriptions).length < 1) {
            return;
          }

          var nextListeners = _extends({}, this.listeners);
          var nextSubscriptionsState = _extends({}, this.state.subscriptionsState);

          Object.keys(subscriptions).forEach(function (key) {
            var subscription = _this3.listeners[key];
            subscription.unsubscribe();

            delete nextListeners[key];
            delete nextSubscriptionsState[key];
          });

          this.listeners = nextListeners;
          this.setState({ subscriptionsState: nextSubscriptionsState });
        }
      }, {
        key: "render",
        value: function render() {
          var firebaseProps = mapFirebase(this.props, this.ref, this.firestore);
          var actionProps = pickBy(firebaseProps, function (prop) {
            return typeof prop === "function";
          });
          var subscriptionProps = this.state.subscriptionsState;
          var props = mergeProps(this.props, _extends({}, actionProps, subscriptionProps));

          return this.state.subscribeSuccess ? createElement(WrappedComponent, props) : React.createElement(
            "div",
            null,
            " ",
            "Failed to load data from Firestore (see console for details).",
            " "
          );
        }
      }]);
      return FirebaseConnect;
    }(Component);

    FirebaseConnect.WrappedComponent = WrappedComponent;
    FirebaseConnect.defaultProps = Component.defaultProps;
    FirebaseConnect.displayName = "FirebaseConnect(" + getDisplayName(WrappedComponent) + ")";
    // FirebaseConnect.contextTypes = FirebaseConnect.propTypes = {
    //   firebaseApp: PropTypes.shape({
    //     database: PropTypes.func.isRequired // eslint-disable-line react/no-unused-prop-types
    //   })
    // };

    return FirebaseConnect;
  };
});

var isCollection = function isCollection(path) {
  return path.split("/").filter(function (x) {
    return x;
  }).length % 2;
};

export { connect, Provider };
